/***************************************************************************
 *   Copyright (C) 2005 by Stefano Zingarini   *
 *   stefano@xiaprojects.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "xematrix.h"
#include "xeconfiguration.h"
#include "xeobject.h"
#include <kdebug.h>


XEMatrix::XEMatrix(QObject *parent, const char *name)
 : QObject(parent, name)
{
	XEObject::xPluginAdd(this);
	// XD System Wide installation
	XEObject::xSetEngineMatrix(this);

}


XEMatrix::~XEMatrix()
{
	xStop();
	XEObject::xPluginDel(this);
}


#include "xematrix.moc"


/*!
    \fn XEMatrix::xGetInfo(QStringList &)
 */
void XEMatrix::xGetInfo(QStringList &)
{
    /// @todo implement me
}


/*!
    \fn XEMatrix::xGetParameter(const QString, QString&)
 */
void XEMatrix::xGetParameter(const QString, QString&)
{
    /// @todo implement me
}


/*!
    \fn XEMatrix::xGetParameterList(QStringList *)
 */
void XEMatrix::xGetParameterList(QStringList *)
{
    /// @todo implement me
}


/*!
    \fn XEMatrix::xParse(const QString &, int, void *)
 */
void XEMatrix::xParse(const QString &, int, void *)
{
    /// @todo implement me
}


/*!
    \fn XEMatrix::xSetup()
 */
void XEMatrix::xSetup()
{
#ifndef ENABLE_FINAL
	kdWarning() << ("XEMatrix::xSetup()\n");
#endif

	// Query for last configuration
	XEConfiguration *Configurator=(XEConfiguration *)XEObject::xGetConfiguration();
	if(Configurator==NULL)
	{
		return;
	}
	ActiveConfiguration=Configurator->xGetConfiguration();
	xUpdateMatrix();
}


/*!
    \fn XEMatrix::xSetupParameter(const QString, const QString)
 */
void XEMatrix::xSetupParameter(const QString, const QString)
{
    /// @todo implement me
}


/*!
    \fn XEMatrix::xStart()
 */
void XEMatrix::xStart()
{
    /// @todo implement me
}


/*!
    \fn XEMatrix::xStop()
 */
void XEMatrix::xStop()
{
    /// @todo implement me
}


/*!
    \fn XEMatrix::xMakeSpace(int, QPoint *)
 */
void XEMatrix::xMakeSpace(int, QPoint *)
{
    /// @todo implement me
}
void XEMatrix::xUpdateMatrix()
{
}
