/***************************************************************************
 *   Copyright (C) 2004 by Stefano                                         *
 *   stefano@xiaprojects.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef XEROOT_H
#define XEROOT_H

#include <xeobject.h>

/*--HEADERSTART--*/

#include <qobject.h>

/**
@author Stefano
*/
class XERoot : public XEObject
{
Q_OBJECT
public:
    XERoot(QObject *parent = 0, const char *name = 0);

    ~XERoot();

public slots:
    void xSetup();
    void xStart();
    void xStop();
    void xStartThis(const QString&);
    void xSetupThis(const QString &);
    void xStopThis(const QString &);
    void xParseTo(const QString &, const QString &, int, void *);
    void xParse(const QString &, int, void *);
signals:
    void xPluginSetup();
    void xPluginStart();
    void xPluginStop();
    void xThisPluginSetup();
    void xThisPluginStart();
    void xThisPluginStop();
    void xParseForeign(const QString &, int, void *);
};

/*--HEADERSTOP--*/

#endif
