/***************************************************************************
 *   Copyright (C) 2005 by Stefano Zingarini   *
 *   stefano@xiaprojects.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "xgdocker.h"
#include "xeobject.h"
#include "xgicon.h"
#include "xeconfiguration.h"

XGDocker::XGDocker(QWidget *parent, const char *name,int i)
 : QWidget(parent, name,i)
{
	// resetting common vars:
	polling=NULL;
	isAnimating=0;
	xLastX=0;
	xLastY=0;
	ActiveConfiguration=NULL;

	XEObject::xPluginAdd(this);
	// XD System Wide installation
	XEObject::xSetEngineDocker(this);

}


XGDocker::~XGDocker()
{
	xStop();
	XEObject::xPluginDel(this);
}


#include "xgdocker.moc"


/*!
    \fn XGDocker::xGetObjectIcon(int)
 */
XGIcon * XGDocker::xGetPointerObjectIcon(int)
{
	return NULL;
}


/*!
    \fn XGDocker::xChangeBackground(const QString)
 */
void XGDocker::xChangeBackground(const QString &)
{
    /// @todo implement me
}


/*!
    \fn XIcon * XGDocker::xGetObjectIcon(int,XIcon *&)
 */
void XGDocker::xGetObjectIcon(int,XGIcon *&)
{
    /// @todo implement me
}
/*!
    \fn XGDocker::xEventTaskAppend(int)
 */
void XGDocker::xEventTaskAppend(int)
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xGetInfo(QStringList &)
 */
void XGDocker::xGetInfo(QStringList &a)
{
	QStringList PluginInformations;
	QString Version=KXDOCKERVERSION;
	Version=Version+"-0.2";
	PluginInformations.append("KXDocker GXDockerBase");	// Project name
	PluginInformations.append(Version); // version
	PluginInformations.append(KXDOCKERDATE); // date
	PluginInformations.append("Stefano");	// Author
	PluginInformations.append("stefano@xiaprojects.com");	// Author mail
	PluginInformations.append("http://www.xiaprojects.com/www/prodotti/kxdocker/main.php?action=download");	// url download
	PluginInformations.append("http://www.xiaprojects.com/www/prodotti/kxdocker/main.php?action=manual");	// url documentation
	PluginInformations.append(QString("http://www.xiaprojects.com/www/prodotti/kxdocker/main.php?action=download")); // url update
	
	a=PluginInformations;
}


/*!
    \fn XGDocker::xStart()
 */
void XGDocker::xStart()
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xStep()
 */
void XGDocker::xStep()
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xStop()
 */
void XGDocker::xStop()
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xEventReloadIcon(int)
 */
void XGDocker::xEventReloadIcon(int)
{
    /// @todo implement me
}


/*!
    \fn XGDocker::wheelEvent(QWheelEvent *)
 */
void XGDocker::wheelEvent(QWheelEvent *)
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xParse(const QString &, int, void *)
 */
void XGDocker::xParse(const QString &, int, void *)
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xUpdateRepaint(int)
 */
void XGDocker::xUpdateRepaint(int)
{
    /// @todo implement me
}



/*!
    \fn XGDocker::xSetup()
 */
void XGDocker::xSetup()
{
	// Query for last configuration
	XEConfiguration *Configurator=(XEConfiguration *)XEObject::xGetConfiguration();
	if(Configurator==NULL)
	{
		return;
	}
	ActiveConfiguration=Configurator->xGetConfiguration();
}


/*!
    \fn XGDocker::getRaised()
 */
int XGDocker::getRaised()
{
    /// @todo implement me
	return 0;
}


/*!
    \fn XGDocker::xEventShowRaised()
 */
void XGDocker::xEventShowRaised()
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xMouseMoveSoftware(int,int)
 */
void XGDocker::xMouseMoveSoftware(int,int)
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xUpdate()
 */
void XGDocker::xUpdate(int,int)
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xCheckBackgroundSeparators()
 */
void XGDocker::xCheckBackgroundSeparators()
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xGetIconIndex(const QObject*)
 */
int XGDocker::xGetIconIndex(const QObject*)
{
	return 0;
}


/*!
    \fn XGDocker::paint(QImage &)
 */
void XGDocker::paint(QImage &)
{
    /// @todo implement me
}


void XGDocker::xDockerRedraw()
{
}

void XGDocker::xDockerRedraw(QObject *)
{
}

void XGDocker::mouseMoveEventSW(int,int,int,Qt::ButtonState )
{
}

void XGDocker::paintIn(QImage &,int)
{}


QImage * XGDocker::xGetBackground()
{
	static QImage immage;
	return &immage;
}


/*!
    \fn XGDocker::xSwapIcons(int,int)
 */
void XGDocker::xSwapIcons(int,int)
{
    /// @todo implement me
}


/*!
    \fn XGDocker::xUpdateSense()
 */
void XGDocker::xUpdateSense()
{
    /// @todo implement me
}
