/***************************************************************************
 *   Copyright (C) 2004 by Stefano                                         *
 *   stefano@xiaprojects.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "xgicon.h"

#include <xeobject.h>
#include <qimage.h>
#include <qbitmap.h>
#include <qwmatrix.h>
#include <qpoint.h>
#include <qpixmap.h>
#include <kpixmapeffect.h>
#include <kimageeffect.h>
#include <kpixmapio.h>
#include <kpixmap.h>
#include <kimageeffect.h>
#include <qdrawutil.h> 
#include <kstandarddirs.h>
#include <kpopupmenu.h>
#include <qfile.h>
#include <qpainter.h>
#include <qfontmetrics.h>
#include <kdebug.h>

//#include "xeplugin_gapplet.h"

#include <kxdocker_setup_sources.h>

//#include <xeplugin_gepillow.h>

//#undef ENABLE_FINAL

XSConfigurations * XGIcon::ActiveConfiguration;
XSConfigurations * XGIconTextMaker::ActiveConfiguration;


QImage *setIntensity(QImage &lavoro,double i)
{
	lavoro=lavoro.convertDepth(32);
	lavoro.setAlphaBuffer(true);
	uint width=lavoro.width();
	uint height=lavoro.height();

	for(uint x=0;x<height;x++)
	{
		uint *riga=(uint *)lavoro.scanLine(x);
		for(uint y=0;y<width;y++)
		{
			uint *p =  (uint *)riga+y;
			uint alfa=qAlpha(*p);
			alfa=uint(alfa*i);
			*p =qRgba(qRed(*p),qGreen(*p),qBlue(*p),alfa);
		}
	}
	return &lavoro;

}
QImage *convertToImage(QImage &lavoro,const QPixmap source, QColor &colore, QColor &colorize)
{
	lavoro=source.convertToImage();
	lavoro.setAlphaBuffer(true);
	uint width=lavoro.width();
	uint height=lavoro.height();
	uint cr=colore.red();
	uint cg=colore.green();
	uint cb=colore.blue();
	float fr=(float)colorize.red()/(float)255;
	float fg=(float)colorize.green()/(float)255;
	float fb=(float)colorize.blue()/(float)255;

	for(uint x=0;x<height;x++)
	{
		uint *riga=(uint *)lavoro.scanLine(x);
		//uint *riga2=(uint *)lavoro.scanLine(x+1);

		int plexiglass=0;
		for(uint y=0;y<width;y++)
		{
			uint *p=(uint *)riga+y;
			//uint alfa=;
			//alfa=uint(alfa*i);
			uint tcr=qRed(*p);
			uint tcg=qGreen(*p);
			uint tcb=qBlue(*p);
/*
			if(tcr==0 && tcg==0 && tcb==0 && plexiglass==0)
			{
				plexiglass=0;
				*p =qRgba(cr,cg,cb,0);
				continue;
			}
*/
			//plexiglass=2;
			uint alfa=255*3;
			alfa=alfa-(cr-tcr);
			alfa=alfa-(cg-tcg);
			alfa=alfa-(cb-tcb);
			//if(qRed(*p)==0 && qGreen(*p)==0 && qBlue(*p)==0)*p =qRgba(cr,cg,cb,qAlpha(*p));
			//else 
			//if(tcr==0 && tcg==0 && tcb==0)*p =qRgba(tcr,tcg,tcb,alfa/2);
			if(alfa>255)
			{
				alfa=250;
			}
			else if(alfa<200)
			{
				if(plexiglass>0)
				{
					plexiglass--;
					alfa=200/(3-plexiglass);
				}
			}
			else {
				plexiglass=2;
/*
				// we have a pixel now we search for a row
				uint *p2=(uint *)riga2+y;
				//uint alfa=;
				//alfa=uint(alfa*i);
				uint tcr2=qRed(*p2);
				uint tcg2=qGreen(*p2);
				uint tcb2=qBlue(*p2);
				uint alfa2=255*3;
				alfa2=alfa2-(cr-tcr2);
				alfa2=alfa2-(cg-tcg2);
				alfa2=alfa2-(cb-tcb2);
				if(alfa2<200 && qAlpha(*p2)<200)
				{
					alfa=200;
					*p2 =qRgba((float)(tcr*fr),(float)(tcg*fg),(float)(tcb*fb),alfa);
				}
*/
			}
			*p =qRgba((float)(tcr*fr),(float)(tcg*fg),(float)(tcb*fb),alfa);

		}
	}
	return &lavoro;

}


XGIcon::XGIcon(QWidget *parent, const char *name)
 : QWidget(parent, name)
{
//	xPillow=NULL;
	xAndZoomCache=0; 	// by default i will not use cache
	xExclude=0;		// its always showed
	xIconTextPillow.xSetFontStyle(&ActiveConfiguration->Icons.OverTextFont);
	xIconTextMini.xSetFontStyle(&ActiveConfiguration->Icons.MiniTextFont);
	hidden=0;
	wExternal=NULL;
	iExternal=0;
	dAnimateToFade=1;
	dAnimateNowFade=1;
	dAnimateStatus=0;
	xIconTextMini.PPillow_Center.create(1,1,32);
	xIconTextMini.PPillow_Center.setAlphaBuffer(false);
	xIconTextMini.PPillow_Center.fill(0);
	xIconTextMini.PPillow_Center.setAlphaBuffer(true);
	iconConfiguration=NULL;
	xClassManager=NULL;
	xExclude=0;
	xAndZoomCache=0;
	xZoom=0;
	xZoomX=0;
	xZoomY=0;
	xSetUpdate=0;
	//dAnimateNowFade=0;
	//dAnimateToFade=0;
	dAnimateStatus=0;
	dAnimateStep=0;

/*
	QImage PPillow_Center;
	QImage PPillow_Left;
	QImage PPillow_Right;
	QImage TMiniBuffer;
	QImage TBuffer;
	QPixmap xImgText;
	QImage xImageText;
	QPixmap	overTextBuffer;
	QBitmap	overTextMask;
*/
}


XGIcon::~XGIcon()
{
}


#include "xgicon.moc"


/*!
    \fn XGIcon::xLoadIcon(const QString &)
 */
void XGIcon::xLoadIcon(const QString &)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xSetZoom(int,int)
 */
inline void XGIcon::xSetZoom(int newZoomX,int newZoomY)
{
	if(newZoomX==newZoomY)
	{
		xSetZoom(newZoomX);
	}
	else
	{
		// Ok we have to enable the double zoom
		xZoom=-1;
		xZoomX=newZoomX;
		xZoomY=newZoomY;
		xSetUpdate=1;
	}
}

/*!
    \fn XGIcon::xSetZoom(int)
 */
void XGIcon::xSetZoom(int newZoom)
{
	if(newZoom==xZoom)return;
	xZoom=newZoom;
#ifndef DISABLE_HUGE_CACHE
	if(xImgCachedZoom[xZoom]>0)
	{
			xImgShowed=xImgCached[xZoom];//.copy();
			xSetUpdate=xImgCachedZoom[xZoom];//.copy();
			/*
			char errore[50];
			sprintf(errore,"Cache: (%d)",xZoom);
			qWarning(errore);
			*/
			return;
			
	}
	
	// Perfomance test QImage::ScaleMin is not good
	//xImgShowed=xImgSource.scale(xZoom,xZoom,QImage::ScaleMin);
	//xImgShowed=KImageEffect::sample(xImgSource,xZoom,xZoom);
	xImgShowed=xImgSource.scale(xZoom,xZoom);
	if(xZoom & xAndZoomCache)
	{
		xImgCached[xZoom]=xImgShowed;
		xImgCachedZoom[xZoom]=1;
	}
#else
	xImgShowed=xImgSource.scale(xZoom,xZoom);
	xImgCachedSingle=xImgShowed.copy();
	xImgCachedZoomSingle=1;
#endif
	xSetUpdate=1;
}


/*!
    \fn XGIcon::xSetHotSpot(const QPoint &)
 */
void XGIcon::xSetHotspot(const QPoint &newPoint)
{
	xHotspot=newPoint;
}


/*!
    \fn XGIcon::xReset()
 */
void XGIcon::xReset()
{
	// Will reset ALL DATA!!!!!
	// do this at startup or when you have to clear this icon
	
	cachePurge();	
	xHotspot.setX(0);
	xHotspot.setY(0);
	xImgShowed.reset();
	xImgSource.reset();
	xPosDefault.setX(0);
	xPosDefault.setY(0);
	xPosition.setX(0);
	xPosition.setY(0);
	xSetUpdate=0;
	xTransparency.resize(0,0);
	xZoom=-1;
	xZoomY=-1;
	xZoomX=-1;
}


/*!
    \fn XGIcon::xSetImage(const QString &)
 */
void XGIcon::xSetImage(const QString &)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xSetImage(const QPixmap &)
 */
void XGIcon::xSetImage(const QPixmap &)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xRepeat(int rWidth,int rHeight)
 */
void XGIcon::xRepeat(int rWidth,int rHeight)
{
/*
#ifdef HAS_KDE31
	xImgSource=xImgSource.smoothScale(rWidth,rHeight);
#else
	KPixmapIO kImgConverter;
	KPixmap pTiled=kImgConverter.convertToPixmap(xImgSource);
	pTiled=KPixmapEffect::createTiled(pTiled,QSize(rWidth,rHeight));
	xImgSource=kImgConverter.convertToImage(pTiled);
	xZoom=-1;
	xZoomY=-1;
	xZoomX=-1;
#endif
*/
	// 0.29
	// does not work!!! transparency is very ugly
	QImage newImage;
		newImage.create(
			rWidth,
			rHeight,
			32);
		
		newImage.setAlphaBuffer(false);
		//TBuffer.fill(QColor(255,0,0).pixel());
		newImage.fill(0);
		newImage.setAlphaBuffer(true);
	int cy=((rHeight+(rHeight%xImgSource.height()))/xImgSource.height());
	int cx=((rWidth+(rWidth%xImgSource.width()))/xImgSource.width());
	for(int wy=0;wy<cy;wy++)
	{
	for(int wx=0;wx<cx;wx++)
	{
		bitBlt(&newImage,
			wx*xImgSource.width(),
			wy*xImgSource.height(),
			&xImgSource,0,Qt::CopyROP);
	}
	}
	xImgSource=newImage;
}



/*!
    \fn XGIcon::xResetIntensity()
 */
void XGIcon::xResetIntensity()
{

#ifndef DISABLE_HUGE_CACHE
	xImgShowed=xImgCached[xZoom].copy();
	xImgCachedZoom[xZoom]=0;
#else
	xImgShowed=xImgCachedSingle.copy();
	xImgCachedZoomSingle=0;
#endif
	//xImgShowed=KImageEffect::intensity(xImgShowed,100);
/*
#ifndef DISABLE_HUGE_CACHE
	xImgCachedZoom[xZoom]=0;
#else
	xImgCachedZoomSingle=0;
#endif
*/
}


/*!
    \fn XGIcon::xSetSmoothZoom(int)
 */
inline void XGIcon::xSetSmoothZoom(int newZoom)
{
	xZoom=newZoom;
#ifndef DISABLE_HUGE_CACHE
	if(xImgCachedZoom[xZoom]<2)
	{
//		xImgShowed=KImageEffect::sample(xImgSource,xZoom,xZoom);
		xImgShowed=xImgSource.smoothScale(xZoom,xZoom);//,QImage::ScaleMin);
		xImgCached[xZoom]=xImgShowed;
		xImgCachedZoom[xZoom]=2;
		return;
	}
	xImgShowed=xImgCached[xZoom];
#else
	if(xImgCachedZoomSingle<2)
	{
		xImgShowed=xImgSource.smoothScale(xZoom,xZoom);
		xImgCachedSingle=xImgShowed.copy();
		xImgCachedZoomSingle=2;
		return;
	}
	xImgShowed=xImgCachedSingle;
#endif
}


/*!
    \fn XGIcon::cachePurge()
 */
void XGIcon::cachePurge()
{
	/*
	for(int i=0;i<MAX_CACHE_ICONS;i++)
	{
		xImgCachedZoom[i]=0;
		xImgCached[i].reset();
	}
	*/
	// Ok we repaint only this icon
	// 0.38 with steps update the Original not the Source...
	//
	// 0.39
	// 20060408 New engine 1.1.2 with xTaskManager which support fading this code has being moved to gPluginSDK
	/*
	if(sender()==xClassManager)
	{
		xImgSource=xImgOriginal;
	}
	*/
#ifndef DISABLE_HUGE_CACHE
	memset(xImgCachedZoom,0 , MAX_CACHE_ICONS*sizeof(int));
#else
	xImgCachedZoomSingle=0;
#endif
}


/*!
    \fn XGIcon::xSetClass(QObject *)
 */
void XGIcon::xSetClass(QObject *newClassManager)
{
	xClassManager=newClassManager;
	if(connect(this,SIGNAL(xAttach(QObject *)),newClassManager,SLOT(xAttach(QObject *))))
	{
	xAttach(this);
	disconnect(this,SIGNAL(xAttach(QObject *)));
	}
	else 
	{
	xClassManager=NULL;
	}
}


/*!
    \fn XGIcon::xSetText(const QString &)
 */
void XGIcon::xSetText(const QString &newText)
{
	xIconTextPillow.pillowText=newText;
	xIconTextPillow.isTextDrawed=0;
	xIconTextPillow.isPixmapTextDrawed=0;
}


/*!
    \fn XGIcon::xGetFontHeight()
 */
int XGIcon::xGetFontHeight()
{
	QFont	overTextFont;
	
	overTextFont.setFamily(ActiveConfiguration->Icons.OverTextFont.FontFamily);
	overTextFont.setPointSize(ActiveConfiguration->Icons.OverTextFont.FontSize);
	
	QFontMetrics fm( overTextFont);
	
//	int pixelsWide = fm.width("test")+10;
	int pixelsHigh = fm.height();
	return pixelsHigh;
}


/*!
    \fn XGIcon::xGetImage(QImage *&)
 */
void XGIcon::xGetImage(QImage *&pluginimg)
{
	// 1.1.2 with fading
	if(pluginimg==&xImgOriginal)xImgSource=xImgOriginal;
	//    pluginimg=&xImgSource;
	// 0.38 with Steps and animations:
	pluginimg=&xImgOriginal;
}


/*!
    \fn XGIcon::xSetSmoothZoom()
 */
void XGIcon::xSetSmoothZoom()
{
	int oldZoom=xZoom;
#ifndef DISABLE_HUGE_CACHE
	xImgCachedZoom[xZoom]=0;
#else
	xImgCachedZoomSingle=0;
#endif
	xZoom=0;
	xSetSmoothZoom(oldZoom);
}


/*!
    \fn XGIcon::xGetConfiguration(XSGObjectIcon *&)
 */
void XGIcon::xGetConfiguration(const XSGObjectIcon *&a)
{
	a=iconConfiguration;
}


/*!
    \fn XGIcon::xGetPluginConfiguration(QDomNodeList *&)
 */
void XGIcon::xGetPluginConfiguration(const QDomNodeList *&a)
{
	//qWarning("void XGIcon::xGetPluginConfiguration()");
	//qWarning(QString("%1 %1").arg(long(xClassManager)).arg(long(sender())));
	if(sender()!=NULL)xClassManager=(QObject *)sender();

	if(iconConfiguration->PluginConfiguration.count()>0)
	{
		a=&iconConfiguration->PluginConfiguration;
	}
	else
	{
		int idx=ActiveConfiguration->ObjectsIcons.find(iconConfiguration);
		if(idx<0)
		{
			a=&iconConfiguration->PluginConfiguration;
			return;
		}
		XSGObjectIcon *iConf=ActiveConfiguration->ObjectsIcons.at(idx);
		// Creating fake document
		QDomDocument 	doc( "KXDocker_Conf" );
		// the fake root
		QDomElement fakeRoot=doc.createElement("FakeRoot");
		// appending childs
		doc.appendChild(fakeRoot);
		// now creating the configuration
		QDomElement CreatingCfg=doc.createElement("pluginconf");
		// Now appending to the configuration
		fakeRoot.appendChild(CreatingCfg);
		iConf->PluginConfiguration=fakeRoot.childNodes();
		a=&iconConfiguration->PluginConfiguration;
		//qWarning("End of explode of plugin icon");
	}
}




/*!
    \fn XGIcon::xRedraw()
 */
void XGIcon::xRedraw()
{
    xRefresh(this);
}


/*!
    \fn XGIcon::xSetZoom()
 */
void XGIcon::xSetZoom()
{
	int oldZoom=xZoom;
#ifndef DISABLE_HUGE_CACHE
	xImgCachedZoom[xZoom]=0;
#else
	xImgCachedZoomSingle=0;
#endif
	xZoom=0;
	xSetZoom(oldZoom);
}


/*!
    \fn XGIcon::xStartAnimating()
 */
void XGIcon::xStartAnimating()
{
	xEventStartAnimating();
}


/*!
    \fn XGIcon::xStopAnimating()
 */
void XGIcon::xStopAnimating()
{
    xEventStopAnimating();
}


/*!
    \fn XGIcon::createPopup()
 */
void XGIcon::createPopup()
{
	// TODO: make XEConfiguration more complex!!!!!!!!
	// by moving this functions to it
	//iconConfiguration->PluginPopupMenu=new KPopupMenu();
	
}


/*!
    \fn XGIcon::getPopupMenu(KPopupMenu *&)
 */
void XGIcon::getPopupMenu(KPopupMenu *&)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xStartClass()
 */
void XGIcon::xStartClass()
{
    // emit signal
    xStart();
}


/*!
    \fn XGIcon::xSetupClass()
 */
void XGIcon::xSetupClass()
{
    // emit signal
    xSetup();
}


/*!
    \fn XGIcon::xGetPluginPopupMenu(KPopupMenu *&)
 */
void XGIcon::xGetPluginPopupMenu(KPopupMenu *&a)
{
	a=iconConfiguration->PluginPopupMenu;
	
}


/*!
    \fn XGIcon::xEnabledClickClass()
 */
int XGIcon::xEnabledClickClass()
{
	int a=0;
	xEnabledClick(a);
	return a;
}


/*!
    \fn XGIcon::xEventClickClass(int,int,int)
 */
void XGIcon::xEventClickClass(int x ,int y,int b)
{
    xEventClick(this,x,y,b,ActiveConfiguration->Icons.Size);
}


/*!
    \fn XGIcon::xStopClass()
 */
void XGIcon::xStopClass()
{
//	qWarning("void XGIcon::xStopClass()");
	emit xStop();
}


/*!
    \fn XGIcon::xRunConfiguratorClass()
 */
void XGIcon::xRunConfiguratorClass()
{
	emit xRunConfigurator();
}



/*!
    \fn XGIcon::xSetIconEXE(const QString &)
 */
void XGIcon::xSetIconEXE(const QString &)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xGetIconEXE(QString &)
 */
void XGIcon::xGetIconEXE(QString &bName)
{
	bName=iconConfiguration->Actions.onClickExec;
}


/*!
    \fn XGIcon::xGetIconImgFile(QString &)
 */
void XGIcon::xGetIconImgFile(QString &bName)
{
	bName=iconConfiguration->Images.imgFileName;
}


/*!
    \fn XGIcon::xGetIconName(QString &)
 */
void XGIcon::xGetIconName(QString &bName)
{
	bName=iconConfiguration->Info.Name;
}


/*!
    \fn XGIcon::xSetIconImgFile(const QString &)
 */
void XGIcon::xSetIconImgFile(const QString &)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xSetIconName(const QString &)
 */
void XGIcon::xSetIconName(const QString &)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xSetOverText(const QString &)
 */
void XGIcon::xSetOverText(const QString &)
{
    /// @todo implement me
//iconConfiguration
}


/*!
    \fn XGIcon::xDesaturate(float)
 */
void XGIcon::xDesaturate(float i)
{
	QImage lavoro=xImgSource;
	/*
	QImage lavoro;
		lavoro.create(
			rWidth,
			rHeight,
			32);
		
		lavoro.setAlphaBuffer(false);
		//TBuffer.fill(QColor(255,0,0).pixel());
		lavoro.fill(0);
		lavoro.setAlphaBuffer(true);
	*/

	//lavoro=lavoro.convertDepth(32);
	//lavoro.setAlphaBuffer(true);
	
/*
	const float RGB2GRAY_Red=0.2989/1.0;
	const float RGB2GRAY_Green=0.5870/1.0;
	const float RGB2GRAY_Blue=0.1140/1.0;
*/

	uint width=lavoro.width();
	uint height=lavoro.height();

	for(uint x=0;x<height;x++)
	{
		uint *riga=(uint *)lavoro.scanLine(x);
		for(uint y=0;y<width;y++)
		{
			uint *p =  (uint *)riga+y;
//			int h,s,v;
			uint Red=qRed(*p);
			uint Green=qGreen(*p);
			uint Blue=qBlue(*p);
			uint alfa=qAlpha(*p);
	uint maxColor=0;
	if(maxColor<Red)maxColor=Red;
	if(maxColor<Green)maxColor=Green;
	if(maxColor<Blue)maxColor=Blue;

	float RGB2GRAY_Red=(maxColor-Red);
	float RGB2GRAY_Green=(maxColor-Green);
	float RGB2GRAY_Blue=(maxColor-Blue);


			//alfa=uint((((float)alfa)/(float)100)*(float)i);
			*p =qRgba((int)((Red)+(float)RGB2GRAY_Red*i),
				(int)((Green)+(float)RGB2GRAY_Green*i),
				(int)((Blue)+(float)RGB2GRAY_Blue*i),
				alfa);
		}
	}
	
	xImgSource=lavoro;

}


/*!
    \fn XGIcon::xFade(int)
 */
void XGIcon::xFade(int i)
{
	fFade((double)i/(double)100);
}


/*!
    \fn XGIcon::xEventPostSetIconPos(int,int,int,int)
 */
void XGIcon::xEventPostSetIconPos(int N,int X,int Y,int Size)
{
	emit xEventSetIconPos(N,X,Y,Size);
}

XGIconTextMaker::XGIconTextMaker()
{
	PillowIsLoaded=0;
	BackgroundPath="";
	FontStyle=&ActiveConfiguration->Icons.OverTextFont;

	PPillow_Center.create(1,1,32);
	PPillow_Center.setAlphaBuffer(false);
	PPillow_Center.fill(0);
	PPillow_Center.setAlphaBuffer(true);

	PPillow_Left.create(1,1,32);
	PPillow_Left.setAlphaBuffer(false);
	PPillow_Left.fill(0);
	PPillow_Left.setAlphaBuffer(true);

	PPillow_Right.create(1,1,32);
	PPillow_Right.setAlphaBuffer(false);
	PPillow_Right.fill(0);
	PPillow_Right.setAlphaBuffer(true);

	TMiniBuffer.create(1,1,32);
	TMiniBuffer.setAlphaBuffer(false);
	TMiniBuffer.fill(0);
	TMiniBuffer.setAlphaBuffer(true);

	TBuffer.create(1,1,32);
	TBuffer.setAlphaBuffer(false);
	TBuffer.fill(0);
	TBuffer.setAlphaBuffer(true);

	xImageText.create(1,1,32);
	xImageText.setAlphaBuffer(false);
	xImageText.fill(0);
	xImageText.setAlphaBuffer(true);




}
XGIconTextMaker::~XGIconTextMaker()
{
}
void XGIconTextMaker::xDrawText()
{
	// this will create a QImage image to draw the text on the screen
	xImgText.resize(0,0);
	if(pillowText.length() && FontStyle!=NULL)
	{
		isTextDrawed=1;
		QPainter Pencil;
		QFont	overTextFont;
		QColor	overTextColor;
		// load how to draw
		/*QString FontFamily;
		if(FontStyle->FontFamily=="")FontFamily="Bitstream Vera Sans Mono";
		else FontFamily=FontStyle->FontFamily;
		*/
		int FontSize;
		if(FontStyle->FontSize<4)FontSize=10;
		else FontSize=FontStyle->FontSize;

		overTextFont.setFamily(FontStyle->FontFamily);
		overTextColor.setRgb(
			FontStyle->FontRed,
			FontStyle->FontGreen,
			FontStyle->FontBlue
			);
		overTextBuffer.resize(800,PILLOWMAXHEIGHT);
		//overTextMask.resize(800,60);
		//overTextMask.fill(Qt::color0);
		//overTextBuffer.fill(overTextColor);
		//overTextBuffer.fill(QColor(0,0,0));

		overTextFont.setBold(FontStyle->Bold);
		overTextFont.setItalic(FontStyle->Italic);
		overTextFont.setWeight(FontStyle->Weight);
		overTextFont.setPointSize(FontSize);
		overTextFont.setStyleStrategy((QFont::StyleStrategy)(QFont::PreferAntialias|QFont::PreferQuality));

		// starting draw the text on the pillow
		Pencil.begin(&overTextBuffer);
			// load up the font
			Pencil.setFont(overTextFont);
			// text align
			QRect overTextRect;
			// the rectangle of text
			QFontMetrics fm( overTextFont);
			int pixelsWide = fm.width(pillowText)+10;
			int pixelsHigh = fm.height();
			overTextRect.setLeft(0);
			overTextRect.setRight(pixelsWide);
			overTextRect.setTop(0);
			overTextRect.setBottom(pixelsHigh);
			QRect rTesto=Pencil.boundingRect(overTextRect,Qt::AlignHCenter,pillowText);
		// Ok got the right rect
		Pencil.end();
		overTextBuffer.resize(pixelsWide,pixelsHigh);
		overTextBuffer.fill(QColor(0,0,0));
		if(!PillowIsLoaded)xPreparePillow(overTextRect);
		/*
		if(PillowIsLoaded!=overTextRect.left())
		{
			PPillow_Center=PPillow_Center.smoothScale(pixelsWide+20,pixelsHigh+10);
			PillowIsLoaded=pixelsWide;
		}
		*/
		
	//0.27
/*  	xTextDecentre=(ActiveConfiguration->Icons.SizeBig-
  			rTesto.right()-rTesto.left())/2;
  */		
 	//xTextDecentre=(rTesto.right()-rTesto.left())/2;
	//const int xTextSx=20;
	//const int xTextEx=pixelsWide+xTextSx;
	const int xTextEx=pixelsWide;
	const int xTextSy=3;
	const int xTextEy=pixelsHigh+xTextSy;
/***********************************************/
		// now setup the transparency
		// 0.40
		//overTextBuffer.setMask(overTextMask);
		xTextDecentre=pixelsWide/2+(pixelsHigh+10);
		int xPPCW=pixelsWide-10;//-6;
		int xPPLS;
		if(xPPCW<1){
			xPPCW=2;
		}
		xPPLS=xTextDecentre-(xPPCW)/2-(pixelsHigh+10);
		int xPPCS=xPPLS+(pixelsHigh+10);

		TBuffer.create(
			xTextDecentre*2,
			pixelsHigh+7,
			32);
		
		TBuffer.setAlphaBuffer(false);
		//TBuffer.fill(QColor(255,0,0).pixel());
		TBuffer.fill(0);
		TBuffer.setAlphaBuffer(true);


		bitBlt(&TBuffer,xPPLS,0,&PPillow_Left,Qt::CopyROP);
		bitBlt(&TBuffer,xPPCS,0,&PPillow_Center,0,0,xPPCW,pixelsHigh+7,Qt::CopyROP);
		bitBlt(&TBuffer,xPPCS+xPPCW,0,&PPillow_Right,Qt::CopyROP);
		// 0.40 _ 1
		//overTextBuffer.convertFromImage(PPillow_Center);
/***********************************************/
/*
	overTextRect.setLeft(xTextSx+1);
	overTextRect.setTop(xTextSy+1);
	overTextRect.setRight(xTextEx+1);
	overTextRect.setBottom(xTextEy+1);
*/
	// starting drawing the text
		QColor bianco=QColor(255,255,255);
  	Pencil.begin(&overTextBuffer);
/*
		overTextRect.setLeft(0);
		overTextRect.setRight(pixelsWide);
		overTextRect.setTop(1);
		overTextRect.setBottom(pixelsHigh+1);
		Pencil.setPen(QColor(128,128,128));
  		Pencil.drawText (overTextRect ,0,pillowText);
		overTextRect.setLeft(1);
		overTextRect.setRight(pixelsWide+1);
		overTextRect.setTop(1);
		overTextRect.setBottom(pixelsHigh+1);
  		Pencil.drawText (overTextRect ,0,pillowText);
*/
  		Pencil.setFont(overTextFont);
 		Pencil.setBackgroundMode(Qt::TransparentMode );
		overTextRect.setLeft(0);
		overTextRect.setRight(pixelsWide);
		overTextRect.setTop(0);
		overTextRect.setBottom(pixelsHigh);
		Pencil.setPen(bianco);
		Pencil.drawText (overTextRect ,0,pillowText);
	Pencil.end();

	// 0.40 2
		/*
		overTextRect.setLeft(0);
		overTextRect.setTop(xTextSy);
		overTextRect.setRight(xTextEx*2);
		overTextRect.setBottom(pixelsHigh*2+xTextSy);
		overTextFont.setPointSize(FontSize*2);
		*/
/*
  	Pencil.begin(&overTextMask);
  		Pencil.setFont(overTextFont);
  		Pencil.setPen(Qt::color1);
  		Pencil.drawText (overTextRect ,0,pillowText);
  	Pencil.end();
	overTextBuffer.setMask(overTextMask);
*/
/***********************************************/

		QImage ITextBuffer;
		convertToImage(ITextBuffer,overTextBuffer,bianco,overTextColor);
		//ITextBuffer=ITextBuffer.smoothScale(ITextBuffer.width()/2,ITextBuffer.height()/2);
		//bitBlt(&TBuffer,7,3,&ITextBuffer,Qt::CopyROP);
		// 0.40 _ 1
		// blur

		//bitBlt(&TBuffer,xPPCS,0,&ITextBuffer,0,0,xPPCW,pixelsHigh+7,Qt::CopyROP);
		QImage ITextBufferBlend=ITextBuffer.copy();
		// MAXIMUN number is 3 writes because more are too cpu intensive
		bitBlt(&TBuffer,xPPCS,3,&ITextBuffer,0,0,xPPCW,pixelsHigh+7,Qt::CopyROP);
		bitBlt(&TBuffer,xPPCS+1,3+1,setIntensity(ITextBufferBlend,0.5),0,0,xPPCW,pixelsHigh+7,Qt::CopyROP);
		//bitBlt(&TBuffer,xPPCS+1,3+1,setIntensity(ITextBufferBlend,0.3),0,0,xPPCW,pixelsHigh+7,Qt::CopyROP);

// 3
/*
  QPainter pixPainter;
  int spread = 2;
  QPixmap textPixmap(pixelsWide+ spread * 2 + 2,pixelsHigh+ spread * 2 + 2);
  textPixmap.fill(QColor(0,0,0));
  textPixmap.setMask( textPixmap.createHeuristicMask(TRUE) );
  pixPainter.begin(&textPixmap);
  pixPainter.setPen(white);    // get the pen from the root painter
  pixPainter.setFont(p->font()); // get the font from the root painter
  wordWrap()->drawText( &pixPainter, spread, spread, align | KWordWrap::Truncate );
  pixPainter.end();

  return new QImage(m_shadow->makeShadow(textPixmap, shadowColor));


*/

/***********************************************/

		xImageText=TBuffer;
	}

	//overTextMask=overTextBuffer;
	// 0.34
	
	//bitBlt(&overTextMask,0,0,&overTextBuffer,Qt::CopyROP);
	//
	//xImgText=overTextBuffer2;
}

inline void XGIconTextMaker::xPreparePillow(QRect &overTextRect)
{

		// get the pillow image
		QString PPath="";
		if(FontStyle==NULL)PPath=ActiveConfiguration->Icons.OverTextFont.BackgroundPath;
		else PPath=FontStyle->BackgroundPath;
		if(BackgroundPath!="")PPath=BackgroundPath;
		QString CuscinoName=PPath;
		// TODO: any icon can have a pillow
		CuscinoName=CuscinoName+"/background-center.png";
		// find resources
		QFile a(::locate("data",CuscinoName));
		if(!a.exists() || CuscinoName==QString::null)
		{
			CuscinoName="kxdocker/themes/pillow/pillow_transparent/background-center.png";
		}
		// load base image pillow
		PPillow_Center.load(::locate("data",CuscinoName));
		/**/
		CuscinoName=PPath;
		CuscinoName=CuscinoName+"/background-left.png";
		a.setName(::locate("data",CuscinoName));
		if(!a.exists() || CuscinoName==QString::null)
		{
			CuscinoName="kxdocker/themes/pillow/pillow_transparent/background-left.png";
		}
		// load base image pillow
		PPillow_Left.load(::locate("data",CuscinoName));
		/**/
		CuscinoName=PPath;
		CuscinoName=CuscinoName+"/background-right.png";
		a.setName(::locate("data",CuscinoName));
		if(!a.exists() || CuscinoName==QString::null)
		{
			CuscinoName="kxdocker/themes/pillow/pillow_transparent/background-right.png";
		}
		// load base image pillow
		PPillow_Right.load(::locate("data",CuscinoName));

		// 0.36 if the text is around 2 chars...
		//PPillow_Center=PPillow_Center.smoothScale(800,overTextRect.bottom()+7);
//0.40 no tile
/*
	QImage PPillow_Center2;
	int rHeight=overTextRect.bottom()+7;
	QImage PPillow_Center3=PPillow_Center.smoothScale(PPillow_Center.width(),rHeight,QImage::ScaleMin);
	int rWidth=800;
	PPillow_Center2.create(rWidth,rHeight,32);
	PPillow_Center2.setAlphaBuffer(false);
	PPillow_Center2.fill(0);
	PPillow_Center2.setAlphaBuffer(true);
	for(int wy=0;wy<rHeight/PPillow_Center.height();wy++)
	{
		for(int wx=0;wx<rWidth/PPillow_Center.width();wx++)
		{
			bitBlt(&PPillow_Center2,
				wx*PPillow_Center3.width(),
				wy*rHeight,
				&PPillow_Center3,0,Qt::CopyROP);
		}
	}
*/
// 0.40
/*
	QImage PPillow_Center2=PPillow_Center.smoothScale(800,overTextRect.bottom()+7,QImage::ScaleMin);
	if(PPillow_Center2.width()<1)PPillow_Center=PPillow_Center.smoothScale(1,overTextRect.bottom()+7);
	else PPillow_Center=PPillow_Center2;
*/
		if(PPillow_Center.width()<1)
		{
			QImage newImage;
			newImage.create(1,1,32);
			newImage.setAlphaBuffer(false);
			//TBuffer.fill(QColor(255,0,0).pixel());
			newImage.fill(0);
			newImage.setAlphaBuffer(true);
			PPillow_Center=newImage;
			PPillow_Left=newImage;
			PPillow_Right=newImage;
		}
		else
		{
// 0.40
/*
			// tiling background to allow lwp using themes
			QImage newImage;
			const int rWidth=800;
			const int rHeight=overTextRect.bottom()+7;
	
			newImage.create(
				rWidth,
				overTextRect.bottom()+7,
				32);
			
			newImage.setAlphaBuffer(false);
			//TBuffer.fill(QColor(255,0,0).pixel());
			newImage.fill(0);
			newImage.setAlphaBuffer(true);
			for(int wy=0;wy<rHeight/PPillow_Center.height();wy++)
			{
				for(int wx=0;wx<rWidth/PPillow_Center.width();wx++)
				{
					bitBlt(&newImage,
						wx*PPillow_Center.width(),
						wy*PPillow_Center.height(),
						&PPillow_Center,0,Qt::CopyROP);
				}
			}
			PPillow_Center=newImage;
*/
	PPillow_Center=PPillow_Center.smoothScale(800,overTextRect.bottom()+7);

			//******************************************/
	
			PPillow_Left=PPillow_Left.smoothScale(overTextRect.bottom()+10,overTextRect.bottom()+7);
	
			PPillow_Right=PPillow_Right.smoothScale(overTextRect.bottom()+10,overTextRect.bottom()+7);
		}
/*
		if(pillowText.length()>1 ||pillowText=="")
		{
		PPillow_Center=PPillow_Center.smoothScale(800,overTextRect.bottom()+7);
		PPillow_Left=PPillow_Left.smoothScale(overTextRect.bottom()+10,overTextRect.bottom()+7);

		PPillow_Right=PPillow_Right.smoothScale(overTextRect.bottom()+10,overTextRect.bottom()+7);
		}
		else
		{
		PPillow_Center=PPillow_Center.smoothScale(3,overTextRect.bottom()+7);
		PPillow_Left=PPillow_Left.smoothScale(overTextRect.bottom()+10,overTextRect.bottom()+7);
		PPillow_Right=PPillow_Right.smoothScale(overTextRect.bottom()+10,overTextRect.bottom()+7);
		}
*/

		/*
		qWarning(QString("Pillow [%1][%1][%1]")
			.arg(PPillow_Left.width())
			.arg(PPillow_Center.width())
			.arg(PPillow_Right.width())
			);
		*/
	PillowIsLoaded=1;
}

inline void XGIconTextMaker::xSetFontStyle(const XSCfgTextFont *style)
{
	FontStyle=style;
}


/*!
    \fn XGIconTextMaker::xSetText(const QString &)
 */
void XGIconTextMaker::xSetText(const QString &newText)
{
	pillowText=newText;
	isTextDrawed=0;
	isPixmapTextDrawed=0;
}


/*!
    \fn XGIcon::xSetText(const QString &,int)
 */
void XGIcon::xSetText(const QString &newText,int idx)
{
	switch(idx)
	{
		case 0:
		xSetText(newText);
		break;
		case 1:
		xSetMiniText(newText);
		break;
	}
}


/*!
    \fn XGIcon::xSetMiniText(const QString &)
 */
void XGIcon::xSetMiniText(const QString &newText)
{
	xIconTextMini.pillowText=newText;
	xIconTextMini.isTextDrawed=0;
	xIconTextMini.isPixmapTextDrawed=0;
}


/*!
    \fn XGIcon::xSetTextManagedBy(int,int)
 */
void XGIcon::xSetTextManagedBy(int idText,int intManager)
{
	int idx=ActiveConfiguration->ObjectsIcons.find(iconConfiguration);

	if(idx<0)return;
	XSGObjectIcon *iConf=ActiveConfiguration->ObjectsIcons.at(idx);

	switch(idText)
	{
		case 1:
		iConf->Tasks.MiniTextShow=intManager;
		break;
	}
}


/*!
    \fn XGIconTextMaker::xSetBackgroundPath(const QString &)
 */
void XGIconTextMaker::xSetBackgroundPath(const QString &newPath)
{
	BackgroundPath=newPath;
	PillowIsLoaded=0;
	isPixmapTextDrawed=0;
}


inline QPixmap *XGIconTextMaker::xGetPixmapText()
{
	if(isPixmapTextDrawed==0)
	{
		isPixmapTextDrawed=1;
		xImgText.convertFromImage(xImageText);
	}
	return &xImgText;
}


void XGIcon::xMouseMoved(int xMouse,int yMouse,int xDocker,int yDocker,int iconIndex,int iconSize)
{
	emit xEventMouseMoved(xMouse,yMouse,xDocker,yDocker,iconIndex,iconSize);
}


/*!
    \fn XGIcon::xSetOverlayImage(int,int,const QPixmap &)
 */
void XGIcon::xSetOverlayImage(int x,int y,const QPixmap &pp)
{
	QImage pi=pp.convertToImage();
	setOverlay(x,y,pi);
}


/*!
    \fn XGIcon::xSetOverlayImage(int,int,const QImage &)
 */
void XGIcon::xSetOverlayImage(int x,int y,const QImage &pi)
{
	setOverlay(x,y,pi);
}


/*!
    \fn XGIcon::xSetOverlayImage(int,int,const QString &)
 */
void XGIcon::xSetOverlayImage(int x,int y,const QString &ps)
{
//qWarning(ps);
	QImage pi;
	if(ps==QString::null || ps=="")pi.reset();
	else if(!pi.load(ps))pi.reset();
	setOverlay(x,y,pi);

}


/*!
    \fn XGIcon::setOverlay(int,int,const QImage &)
 */
inline void XGIcon::setOverlay( int x,int y,const QImage &pi)
{
	if(pi.isNull() || pi.width()<1)
	{
		xImgSource=xImgOriginal.copy();
		xImgOverlay.reset();
		// done on next Step
		//dAnimateStatus=dAnimateStatus& (~(1<<1));
	}
	else
	{
		xImgOverlay=pi.smoothScale(xImgOriginal.width(),xImgOriginal.height(),QImage::ScaleMax);
		if(pi.width()!=pi.height())
		{
			// may be spinner!
			//xImgOverlay=pi;
			dAnimateStep=0;
			dAnimateStatus=dAnimateStatus|1<<1;
			fSpin();
			cachePurge();
			return;
		}
		else
		{
			switch(x)
			{
				case -1:
					// Stretched
					{
					QImage piRaster;
					piRaster=pi;
					piRaster=piRaster.smoothScale(xImgSource.width(),xImgSource.height());
					bitBlt(&xImgSource,0,0,&piRaster,0,Qt::CopyROP);
					}
				break;
				case -2:
					// Centered
					{
					int dw=xImgSource.width()/2-pi.width()/2;
					bitBlt(&xImgSource,dw,dw,&pi,0,Qt::CopyROP);
					}
				break;
				default:
					// X, Y
					bitBlt(&xImgSource,x,y,&pi,0,Qt::CopyROP);
				break;
			}
		}

	}
	cachePurge();
	xSetSmoothZoom();

}


/*!
    \fn XGIcon::xGetHidden()
 */
int XGIcon::xGetHidden()
{
    return hidden;
}


/*!
    \fn XGIcon::xSetHidden()
 */
void XGIcon::xSetHidden()
{
	hidden=1;
}


/*!
    \fn XGIcon::xSetHidden(int)
 */
void XGIcon::xSetHidden(int i)
{
    hidden=i;
}


/*!
    \fn XGIcon::xStep()
 */
void XGIcon::xStep()
{
	//qWarning("void XGIcon::xStep()");
	int doSmoothZoom=0;
	const double FADESTEPUNIT=0.1;
if(dAnimateStatus&1)
{
	if(dAnimateNowFade<dAnimateToFade-FADESTEPUNIT)
	{
//qWarning(QString("void XGIcon::xStep() %1").arg(dAnimateNowFade));
		//dAnimateNowFade=dAnimateNowFade+0.2;
		//dAnimateNowFade=(dAnimateToFade+dAnimateNowFade)/2;
		dAnimateNowFade=dAnimateNowFade+FADESTEPUNIT;
		xImgSource=xImgOriginal;
		xImgSource.detach();
		fFade(dAnimateNowFade);
		//xSetZoom();
	}
	else if(dAnimateNowFade>dAnimateToFade+FADESTEPUNIT)
	{
//qWarning(QString("void XGIcon::xStep() %1").arg(dAnimateNowFade));
		xImgSource=xImgOriginal;
		xImgSource.detach();
		//dAnimateNowFade=dAnimateNowFade-0.2;
		dAnimateNowFade=dAnimateNowFade-FADESTEPUNIT;
		//dAnimateNowFade=(dAnimateToFade+dAnimateNowFade)/2;
		fFade(dAnimateNowFade);
		//xSetZoom();
	}
	else
	{
//qWarning(QString("void XGIcon::xStep() %1 end").arg(dAnimateNowFade));
		dAnimateStatus=dAnimateStatus& (~(1<<0));
		if(dAnimateNowFade>0.8)
		{
			xImgSource=xImgOriginal;
			xImgSource.detach();
			dAnimateNowFade=1;
		}
		// the animation is at end so we need to clean all caches
		cachePurge();
		// we do a good smoothing
		//xSetSmoothZoom();
		doSmoothZoom++;
	}
		//qWarning(QString("%1").arg(dAnimateNowFade));
}
// at this time we cannot support more than 1 animation
else
if(dAnimateStatus&1<<1)
{
	fSpin();
	if(dAnimateStatus&(1<<1))
	{}
	else
	{
			xImgSource=xImgOriginal;
			xImgSource.detach();
		cachePurge();
		doSmoothZoom++;
	}
}
	if(doSmoothZoom)xSetSmoothZoom();
	else xSetZoom();
}


/*!
    \fn XGIcon::fFade(double)
 */
inline void XGIcon::fFade(double i)
{
	QImage lavoro=xImgSource;
	/*
	QImage lavoro;
		lavoro.create(
			rWidth,
			rHeight,
			32);
		
		lavoro.setAlphaBuffer(false);
		//TBuffer.fill(QColor(255,0,0).pixel());
		lavoro.fill(0);
		lavoro.setAlphaBuffer(true);
	*/

	//lavoro=lavoro.convertDepth(32);
	//lavoro.setAlphaBuffer(true);
	uint width=lavoro.width();
	uint height=lavoro.height();

	for(uint x=0;x<height;x++)
	{
		uint *riga=(uint *)lavoro.scanLine(x);
		for(uint y=0;y<width;y++)
		{
			uint *p =  (uint *)riga+y;
			uint alfa=qAlpha(*p);
			//alfa=(int)((float)alfa*gi);
			alfa=uint(((float)alfa)*(float)i);
//qWarning(QString("[%1][%1][%1][%1]").arg(*p).arg(alfa).arg(x).arg(y));
//qWarning(QString("[%1][%1][%1][%1]").arg(qAlpha(*p)).arg(alfa).arg(x).arg(y));
			*p =qRgba(qRed(*p),qGreen(*p),qBlue(*p),alfa);
			//*p =qRgba(220,100,x,128);
		}
	}
	dAnimateNowFade=i;
	xImgSource=lavoro;
}


/*!
    \fn XGIcon::xFade(double)
 */
void XGIcon::xFade(double i)
{
	fFade(i);
}


/*!
    \fn XGIcon::xFadeTo(double)
 */
void XGIcon::xFadeTo(double i)
{
	dAnimateToFade=i;
	dAnimateStatus=dAnimateStatus|1;
}


/*!
    \fn XGIcon::fSpin()
 */
void XGIcon::fSpin()
{
	//qWarning("void XGIcon::fSpin()");
	//QImage offScreen;
	xImgSource=xImgOriginal.copy();
	if(xImgOverlay.isNull())
	{
		dAnimateStatus=dAnimateStatus& (~(1<<1));
		return;
	}
	int w=xImgOverlay.width();
	int h=xImgOverlay.height();

	if(w>h)
	{
	//qWarning("void XGIcon::fSpin() w>h");
		int maxstep=w/h;
		if(dAnimateStep>=maxstep)dAnimateStep=0;
		int dw=xImgSource.height()/2-xImgOverlay.height()/2;
		bitBlt(&xImgSource,dw,dw,&xImgOverlay,dAnimateStep*h,0,h,h);
	}
	else
	{
	//qWarning("void XGIcon::fSpin() w<h");
		int maxstep=h/w;
		if(dAnimateStep>=maxstep)dAnimateStep=0;
		int dw=xImgSource.width()/2-xImgOverlay.width()/2;
		bitBlt(&xImgSource,dw,dw,&xImgOverlay,0,dAnimateStep*w,w,w);
		
	}
	//setZoom();
	dAnimateStep++;
	//qWarning("void XGIcon::fSpin() end");
}


/*!
    \fn XGIcon::xColorize(int,int,int)
 */
void XGIcon::xColorize(int,int,int)
{
    /// @todo implement me
}


/*!
    \fn XGIcon::xColorize(double,double,double,double)
 */
void XGIcon::xColorize(double iRed,double iGreen,double iBlue,double iAlpha)
{
#ifndef DISABLE_HUGE_CACHE
	xImgShowed=xImgCached[xZoom].copy();
#else
	xImgShowed=xImgCachedSingle.copy();
#endif
	if(iRed!=0.0)xImgShowed=KImageEffect::channelIntensity(xImgShowed,iRed,KImageEffect::Red);
	if(iGreen!=0.0)xImgShowed=KImageEffect::channelIntensity(xImgShowed,iGreen,KImageEffect::Green);
	if(iBlue!=0.0)xImgShowed=KImageEffect::channelIntensity(xImgShowed,iBlue,KImageEffect::Blue);
	if(iAlpha!=0.0);//setIntensity(xImgShowed,iAlpha);
}


/*!
    \fn XGIcon::xColorize(int,int,int,int)
 */
void XGIcon::xColorize(int,int,int,int)
{
    /// @todo implement me
}
void XGIcon::xSetIntensity(float ratio)
{
	/*
	// TODO: Check this optimizitation with new engines
	if(xImgCachedZoom[xZoom]<3)
	{
		xImgShowed=KImageEffect::intensity(xImgShowed, ratio);
		xImgCachedZoom[xZoom]=3;
	}
	*/
#ifndef DISABLE_HUGE_CACHE
	xImgShowed=xImgCached[xZoom].copy();
#else
	xImgShowed=xImgCachedSingle.copy();
#endif

	xImgShowed=KImageEffect::intensity(xImgShowed,ratio);

}


/*!
    \fn XGIcon::xReSetClass(QObject *)
 */
void XGIcon::xReSetClass(QObject *newClassManager)
{
	xClassManager=newClassManager;
	if(connect(this,SIGNAL(xAttach(QObject *)),newClassManager,SLOT(xReAttach(QObject *))))
	{
		xAttach(this);
		disconnect(this,SIGNAL(xAttach(QObject *)));
	}
	else 
	{
		xClassManager=NULL;
	}
}


/*!
    \fn XGIcon::xGetClass()
 */
QObject * XGIcon::xGetClass()
{
	return xClassManager;
}

/*!
    \fn XGIcon::xFreeClass()
 */
void XGIcon::xFreeClass()
{
	//kdWarning()<<QString("void XGIcon::xFreeClass(%1) check for plugin...\n").arg((int)xClassManager);
	disconnect(this);
	if(xClassManager)
	{
	//	kdWarning()<<QString("void XGIcon::xFreeClass(%1) disconnecting...\n").arg((int)xClassManager);
		disconnect(xClassManager);
	//	kdWarning()<<QString("void XGIcon::xFreeClass(%1) deleting...%1\n").arg((int)xClassManager).arg(XEObject::xGetPluginIndex(xClassManager));
		delete xClassManager;
	//	kdWarning()<<QString("void XGIcon::xFreeClass(%1) check for garbage...%1\n").arg((int)xClassManager).arg(XEObject::xGetPluginIndex(xClassManager));
		xClassManager=NULL;
	}
}
